#include <cppunit/extensions/HelperMacros.h>

#include "src/hwdesc_attributes.h"
#include "src/util.h"

class AttributesTest : public CppUnit::TestFixture
{
    CPPUNIT_TEST_SUITE(AttributesTest);
    CPPUNIT_TEST(testTemperature);
    CPPUNIT_TEST(testMaxSlot);
    CPPUNIT_TEST_SUITE_END();
public:
    void testTemperature();
    void testMaxSlot();
};

CPPUNIT_TEST_SUITE_REGISTRATION(AttributesTest);

void AttributesTest ::testTemperature()
{
    CPPUNIT_ASSERT_EQUAL(attributeToTemperature(0), 1490);   // 149.9 C
    CPPUNIT_ASSERT_EQUAL(attributeToTemperature(0), MAX_TEMP);
    CPPUNIT_ASSERT_EQUAL(attributeToTemperature(255), -805); // -80.5 C
    CPPUNIT_ASSERT_EQUAL(attributeToTemperature(469), -2731); // -273.1  C
    CPPUNIT_ASSERT_EQUAL(attributeToTemperature(470), MIN_TEMP); // -273.2  C
    CPPUNIT_ASSERT_EQUAL(attributeToTemperature(UINT16_MAX), MIN_TEMP); // -273.2 C
}

void AttributesTest::testMaxSlot()
{
    CPPUNIT_ASSERT(dSA::array_size(charging_pulse_table) == 40);
    CPPUNIT_ASSERT(charge_slot_count == 40);
}
